<?php

class DZSFacebookLoginBox{
	public $db_main_options = '';
	public $index = 0;
	public $base_url;
	public $shortcode='advancedtabs';
	public $alwaysembed='off';
	public $pluginmode = "plugin";
	public $lastskin = '';
	private $can_session = true;
	public $capability_admin = 'manage_options';
	private $adminpagename_mainoptions = 'dzsflb-mo';
	private $dbname_main_options = 'dzsflb-mo';
	private $register_errors_str = '';
	function __construct(){
		$this->base_url = plugins_url('', __FILE__) . '/';
//        $this->main_options = get_option('dzsat_options');

		if(function_exists('session_status') && function_exists('session_start')){


			if (session_status() == PHP_SESSION_NONE) {
				session_start();
			}
		}else{
			$this->can_session = false;
		}





		add_action('init', array($this, 'handle_init'));


		$db_main_options_default = array(
			'facebook_app_id'=>'', // -- the old wp memory limit
			'facebook_app_secret'=>'', // -- the old wp memory limit
			'google_recapcha_key'=>'', // -- the old wp memory limit
			'google_recapcha_secret'=>'', // -- the old wp memory limit
			'style_login'=>'', // -- the old wp memory limit
			'style_login_login'=>'', // -- the old wp memory limit
			'style_login_register'=>'', // -- the old wp memory limit
			'extra_css'=>'', // -- the old wp memory limit
		);

		$this->db_main_options = get_option($this->dbname_main_options);

		if(is_array($this->db_main_options)==false){
			$this->db_main_options = array();
		}

		$this->db_main_options = array_merge($db_main_options_default, $this->db_main_options);

//        print_r($db_main_options);


//        echo 'ceva';
		add_action('wp_ajax_dzsflb_submit_mo',array($this,'ajax_submit_mo') ,55);
		add_action('dzsflb_register_user',array($this,'register_user') ,55);


		add_filter('the_content',array($this,'filter_content') );
		add_action('wp_head',array($this,'handle_wp_head') );
		add_action('wp_footer',array($this,'handle_wp_footer') );


		add_shortcode('login_box',array($this,'shortcode_login_box'));

//        echo 'ceva';
	}

	function shortcode_login_box($pargs=array(),$content=''){

		$margs = array(

			'register_username'=>'',
			'register_email'=>'',
			'register_password'=>'',
			'register_confirm_password'=>'',
		);

		$this->register_errors_str = '';

		if($pargs){
			$margs = array_merge($margs,$pargs);
		}

//		print_rr($margs);


		$fout = '';

		$fout.='<a href="#login-box">';
		$fout.=do_shortcode($content);


		$fout.='</a>';

		return $fout;
    }

	function filter_content($content){


		$fout = $content;

		if($this->register_errors_str){
			echo '<div class="dzs-warning dzsflb-warning">'.$this->register_errors_str.'</div>';
		}

		return $fout;
	}

	function ajax_submit_mo(){

		$auxarray = array();
		//parsing post data
		parse_str($_POST['postdata'], $auxarray);



		$this->db_main_options = array_merge($this->db_main_options, $auxarray);


		update_option($this->dbname_main_options, $this->db_main_options);
		echo 'success - '.esc_html__("Options saved",'dzsflb');



		die();
	}

	function handle_wp_footer(){
//        echo 'alceva';
		wp_enqueue_script('dzsflb',$this->base_url.'libs/facebookloginbox/facebookloginbox.js');
		wp_enqueue_style('dzsflb',$this->base_url.'libs/facebookloginbox/facebookloginbox.css');

		if($this->db_main_options['google_recapcha_key']){
			echo '<style>.grecaptcha-badge{display:none; }</style><script type="text/javascript">
        var onloadCallback = function() {

            console.info("RENDER");
            grecaptcha.render(\'html_element\', {
                \'sitekey\' : \''.$this->db_main_options['google_recapcha_key'].'\'
            });
        };
        var onSubmit = function(token) {

            console.info("RENDER onsubmit",token);
            
            document.getElementById("dzsflb-register-form").submit();
        };
    </script>';


			wp_enqueue_script('google-recapcha','https://www.google.com/recaptcha/api.js');
		}

		?>

        <div class="dzsflb-lightbox-controls " style="opacity:0; visibility: hidden;"><div class="dzsflb-lightbox-controls--bg"></div><?php
			//	is-active is-active-account
			?>


            <div class="header-bottom-control header-bottom-control--account " data-type="account">
				<?php
				if(0){
					?><ul class="notices-box"></ul><?php
				}
				?>


                <div class="user-menu--options">





					<?php

					global $user_login;

					if ( is_user_logged_in() ){
						?>

                        <div class="dzsflb_logout">

							<?php
							echo esc_html__( 'Hello', 'dzsflb' );
							echo ', '.$user_login;
							?>

                            </br>

							<?php echo esc_html__( 'You are already logged in.', 'dzsflb' ); ?>

                        </div>

                        <a id="wp-submit" href="<?php echo wp_logout_url(); ?>" title="Logout">
							<?php echo esc_html__( 'Logout', 'dzsflb' ); ?>
                        </a>

						<?php
					}else{


						// -- not logged in


						$facebook_str = '';


						$app_id     = $this->db_main_options['facebook_app_id'];
						$app_secret = $this->db_main_options['facebook_app_secret'];


						if($app_id && $app_secret){



							require_once 'includes/src/Facebook/autoload.php'; // change path as needed

							$fb = new \Facebook\Facebook( [
								'app_id'                => $app_id,
								'app_secret'            => $app_secret,
								'default_graph_version' => 'v2.10',
								//'default_access_token' => '{access-token}', // optional
							] );






							$helper = $fb->getRedirectLoginHelper();


							$redir_url = home_url('?login-via-facebook=on');





							$permissions = array(
								'email',
								'public_profile',
								'user_about_me',
								//					        'picture',
								//                            'user_about_me',
							); // Optional permissions
							$loginUrl = $helper->getLoginUrl($redir_url, $permissions);



//		                    echo ' redir_url - '.admin_url('admin.php?page=dzsvg-mo&tab=10').'<br>';
							$facebook_str.= '<a class="facebook-box custom-a" href="' . htmlspecialchars($loginUrl) . '">'.esc_html__( 'Facebook', 'dzsflb' ).'</a>';


							/*					$facebook_str = '<a href="https://www.facebook.com/v2.2/dialog/oauth?client_id=269610766536363&amp;state=1a6ecaf4228fa4d92848d543cf576564&amp;response_type=code&amp;sdk=php-sdk-5.0.0&amp;redirect_uri=<?php echo urlencode(site_url());?>&amp;scope=email%2Cuser_about_me" class="facebook-box custom-a">'.esc_html__( 'Facebook', 'dzsflb' ).'</a>';*/
						}




						?><div class="tab-header-menu">
                        <span class="tab-header-menu--item tab-header-menu--item--login active"><?php echo esc_html__( 'Login', 'dzsflb' ); ?></span>
                        <span class="tab-header-menu--item tab-header-menu--item--register"><?php echo esc_html__( 'Register', 'dzsflb' ); ?></span>
                        </div>
                        <div class="dzsflb--content">
                            <div class="dzsflb--content--login active">
								<?php

								// -- not logged in

								$args = array(
									'echo'           => false,
									'redirect'       => home_url( '' ),
									'form_id'        => 'loginform',
									'label_username' => esc_html__( 'Username' ),
									'label_password' => esc_html__( 'Password' ),
									'label_remember' => esc_html__( 'Remember Me' ),
									'label_log_in'   => esc_html__( 'Log In' ),
									'id_username'    => 'user_login',
									'id_password'    => 'user_pass',
									'id_remember'    => 'rememberme',
									'id_submit'      => 'wp-submit',
									'remember'       => true,
									'value_username' => NULL,
									'value_remember' => true,
								);

								// Calling the login form.



								?><?php
								$form_str = wp_login_form( $args );


								$form_str = preg_replace("/<p class=\"login-submit\">/", '<hr><p class="login-submit">'.$facebook_str, $form_str);


								echo $form_str;
								//				echo '$form_str - '; print_rr($form_str);
								?></div>

                            <div class="dzsflb--content--register"><?php

								// -- TODO: google recapcha

								?><form id="dzsflb-register-form" method="post" action="">
									<?php
									if($this->db_main_options['google_recapcha_key']){
										echo '<div id="html_element"></div>';
									}
									?>
                                    <p>
                                        <label><?php echo esc_html__( 'Username', 'dzsflb' ); ?>
                                        </label>
                                        <input class="" type="hidden" name="dzsflb_action" aria-required="true" value="register"/>
                                        <input class="input" type="text" name="register_username" aria-required="true" value=""/>

                                    </p>

                                    <p>
                                        <label><?php echo esc_html__( 'Email', 'dzsflb' ); ?>
                                        </label>
                                        <input  class="input" type="text" name="register_email" aria-required="true" value="" />
                                    </p>

                                    <p>
                                        <label><?php echo esc_html__( 'Password', 'dzsflb' ); ?>
                                        </label>
                                        <input  class="input" type="password" name="register_password" aria-required="true" value="" />
                                    </p>

                                    <p class="confirm-password-p">
                                        <label><?php echo esc_html__( 'Confirm password', 'dzsflb' ); ?>
                                        </label>
                                        <input  class="input" type="password" name="register_confirm_password" aria-required="true" value="" />
                                    </p>

									<?php


									if(function_exists('bp_is_active')){

										global $wpdb;


//	    echo '$wpdb - '; print_rr($wpdb);

										$table =$wpdb->base_prefix .'bp_xprofile_fields';
										$results = $wpdb->get_results( "SELECT * FROM $table WHERE group_id = '1'", ARRAY_A );


//	                            echo '$results -'; print_rr($results);

										foreach($results as $ress){
											?>

                                            <p>
                                                <label><?php echo $ress['name']; ?>
                                                </label>
                                                <input  class="input" type="text" name="bp_field_<?php echo $ress['id']; ?>" <?php

												if($ress['is_required']){
													echo ' aria-required="true"';
												}

												?> value="" />
                                            </p>

											<?php
										}
									}
									?>


                                    <hr>
                                    <p class="login-submit">

										<?php echo $facebook_str; ?>

										<?php

										?>
                                        <button class="submit-button g-recaptcha" type="submit" value="register" <?php


										if($this->db_main_options['google_recapcha_key']){
											$recapcha_key = $this->db_main_options['google_recapcha_key'];
											echo '  data-sitekey="'.$recapcha_key.'" data-callback=\'onSubmit\'';
										}

										?> ><?php echo esc_html__( 'Register', 'dzsflb' ); ?></button>
										<?php
										?>
                                    </p>
                                </form><?php

								?></div></div>
						<?php
					}

					?>
                </div><!-- end user-menu--options -->



            </div>
			<?php
			?></div>
		<?php

	}


	function register_user($pargs = array()){

//	    unset( $args['user_id'] );

//	    extract($args);



		error_log('trying to register user - '.print_rr($pargs,true));



		$margs = array(

			'register_username'=>'',
			'register_email'=>'',
			'register_password'=>'',
			'register_confirm_password'=>'',
		);

		$this->register_errors_str = '';

		if($pargs){
			$margs = array_merge($margs,$pargs);
		}



		$user_id = 0;
		$user_login = '';
		$user_email = '';
		$user_password = '';


		$sw_create_user = true;


		if($this->db_main_options['google_recapcha_key'] && $this->db_main_options['google_recapcha_secret']){




			if(function_exists('curl_version')) {
				$fields_string = '';
				$url           = 'https://www.google.com/recaptcha/api/siteverify';
				$fields        = array(
					'secret'   => $this->db_main_options['google_recapcha_secret'],
					'response' => $_POST['g-recaptcha-response'],
					'remoteip' => $_SERVER["REMOTE_ADDR"],
				);

//url-ify the data for the POST
				foreach ( $fields as $key => $value ) {
					$fields_string .= $key . '=' . $value . '&';
				}
				rtrim( $fields_string, '&' );

//open connection
				$ch = curl_init();

//set the url, number of POST vars, POST data
				curl_setopt( $ch, CURLOPT_URL, $url );
				curl_setopt( $ch, CURLOPT_POST, count( $fields ) );
				curl_setopt( $ch, CURLOPT_POSTFIELDS, $fields_string );
				curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );

//execute post
				$result = curl_exec( $ch );
//                    print_r($result);

				$result_arr = json_decode( $result );

//                    echo 'ceva-> '; print_r($result_arr);


				if ( $result_arr->success ) {

				}else{

					$this->register_errors_str.=esc_html__( 'something went wrong in google recapcha', 'dzsflb' );
				}
			}
		}




		if ( get_option( 'users_can_register' ) ) {

		}else{

			$this->register_errors_str.=esc_html__( 'site administrator does not allow registration', 'dzsflb' );
        }

		if ( $margs['register_username'] ) {
			$user_login = $margs['register_username'];
		}else{

			$this->register_errors_str.=esc_html__( 'You need to enter username', 'dzsflb' );
		}



		if ( $margs['register_email'] ) {
			$user_email = $margs['register_email'];
		}else{
			$this->register_errors_str.=esc_html__( 'You need to enter email', 'dzsflb' );

		}


		if($margs['register_password']){

			if($margs['register_password']==$margs['register_confirm_password']){



				$user_password = md5($margs['register_password']);
			}else{

				$this->register_errors_str.=esc_html__( 'Passwords must match', 'dzsflb' );
			}
		}else{
			$this->register_errors_str.=esc_html__( 'You need to enter password', 'dzsflb' );

		}

		if($this->register_errors_str){
			$sw_create_user=false;
		}





		error_log( '$this->register_errors_str  - '.$this->register_errors_str);







		if($sw_create_user){

			$user_id = wp_create_user( $user_login, $user_password, $user_email );

			if(is_numeric($user_id)){

				do_action('dzsflb_after_user_register', $user_id);

				$this->my_auto_login($user_id);

				foreach ($margs as $lab=>$val){

					if($val){

						if(strpos($lab,'bp_field_')===0){

							$bp_xfield_id = str_replace('bp_field_','',$lab);
							$date = date('Y-m-d H:i:s');

							global $wpdb;
							$table =$wpdb->base_prefix .'bp_xprofile_data';

							$wpdb->query( $wpdb->prepare(
								"
		INSERT INTO $table
		( field_id,user_id,value,last_updated )
		VALUES ( %d,%d,%s,%s )
	",
								$bp_xfield_id,
								$user_id,
								$val,
								$date
							) );
						}
					}
				}
			}else{

				error_log( '$user_id error  - '.print_r($user_id,true));

				if(is_object($user_id) && isset($user_id->errors)){

//				    error_log( '$user_id error  - '.print_r((string)$user_id->errors,true));

					$this->register_errors_str.=json_encode($user_id->errors);
				}
			}

		}




		return $user_id;

	}
	function my_auto_login( $user_id ) {
		wp_set_auth_cookie( $user_id, false, is_ssl() );
		wp_redirect( site_url() );
		exit;
	}



	function generate_token($id = ''){




		if(!isset($_SESSION[$id])) {
			$token_id = md5(substr(str_shuffle("0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"), 0, 10));
			$_SESSION[$id] = $token_id;
			return $_SESSION[$id];
		}
		return $_SESSION[$id];
	}


	function check_posts(){


		if(isset($_REQUEST['dzsflb_action'])){
			if($_REQUEST['dzsflb_action']=='register'){

				do_action('dzsflb_register_user',$_POST);
			}
		}


















		if(isset($_REQUEST['login-via-facebook']) && $_REQUEST['login-via-facebook']=='on'){

			if(1){

//	            echo 'ceva';;

				$app_id = $this->db_main_options['facebook_app_id'];
				$app_secret = $this->db_main_options['facebook_app_secret'];


				if($app_id) {



					if(function_exists('session_status')){

						if ( ! session_id() ) {
							session_start();
						}

						require_once 'includes/src/Facebook/autoload.php'; // change path as needed


						$fb = new Facebook\Facebook(array(
							'app_id' => $app_id,
							'app_secret' => $app_secret,
							'default_graph_version' => 'v2.10',
						));


						foreach ( $_COOKIE as $k => $v ) {
							if ( strpos( $k, "FBRLH_" ) !== false ) {
								$_SESSION[ $k ] = $v;
							}
						}




						$accessToken = '';

						$helper = $fb->getRedirectLoginHelper();

						if(isset($_GET['state'])){

							$_SESSION['FBRLH_state']=$_GET['state'];
						}






						try {

							// TODO: do we need redir_url ?

							$accessToken = $helper->getAccessToken();
						} catch ( Facebook\Exceptions\FacebookResponseException $e ) {
							// When Graph returns an error
							echo 'Graph returned an error: ' . $e->getMessage();

						} catch ( Facebook\Exceptions\FacebookSDKException $e ) {
							// When validation fails or other local issues

//        print_rr($e->getError());
							echo '<pre>redirect-from-facebook.php - Facebook 26 SDK returned an error: ' . $e->getMessage() . '...';
							print_rr( "__COOKIE__" . print_rr( $_COOKIE, true ));
							print_rr( "__GET__" . print_rr( $_GET, true ) . "__SESSION__" . print_rr( $_SESSION, true ) );
							print_rr( $helper->getPersistentDataHandler() );
							print_rr( $helper->getError() );

							echo '</pre>';
//		exit;
						}




						try {
							// Returns a `Facebook\FacebookResponse` object
							$response = $fb->get('/me?fields=id,name,email,picture,cover{source}', $accessToken);
						} catch(Facebook\Exceptions\FacebookResponseException $e) {
							echo 'Graph returned an error: ' . $e->getMessage();
						} catch(Facebook\Exceptions\FacebookSDKException $e) {
							echo 'Facebook SDK returned an error: ' . $e->getMessage();
						}





//	$redir_url = admin_url('admin.php?page=dzsvg-about');



						if($accessToken ){



							$graphNode = $response->getGraphUser();

//						    $this->register_errors_str.=($graphNode);
//						    $this->register_errors_str.=print_r($graphNode->getFieldNames(),true);

							$pic = $graphNode->getField('picture');



//						    $this->register_errors_str.=($graphNode->getField('picture')) ; // From GraphNode


//						    $this->register_errors_str.=($pic->getField('url'));


							$facebook_uid = $graphNode->getField('id');
							$facebook_email = $graphNode->getField('email');

							if($facebook_uid){


								// -- let's do some tests

								if(get_option('dzsfb_registered_fb_id_to_wp_id_'.$facebook_uid)){



									$user_id = get_option('dzsfb_registered_fb_id_to_wp_id_'.$facebook_uid);
									error_log("register based on email exist ".$facebook_uid.'|'.$user_id.'}');
									$this->my_auto_login($user_id);



								}else{

									if ( $user_id = email_exists( $facebook_email ) ) {

										error_log("register based on email exist ".$facebook_uid.'|'.$user_id.'}');
										$this->my_auto_login($user_id);




									}else{
										$user_login_arr = explode('@',$facebook_email);
										$user_login = $user_login_arr[0];

										$user_password = md5('1234');

										$user_id = wp_create_user($user_login,$user_password,$facebook_email);


										if(is_numeric($user_id)){

											do_action('dzsflb_after_user_register', $user_id);



											error_log("register based on id ".$facebook_uid.'|'.$user_id.'}');
											update_option('dzsfb_registered_fb_id_to_wp_id_'.$facebook_uid,$user_id);
											$this->my_auto_login($user_id);

										}else{

											error_log( '$user_id error  - '.print_r($user_id,true));

											if(is_object($user_id) && isset($user_id->errors)){

//				    error_log( '$user_id error  - '.print_r((string)$user_id->errors,true));

												$this->register_errors_str.=json_encode($user_id->errors);
											}
										}
									}
								}

							}else{
								$this->register_errors_str.= esc_html__( 'Facebook did not return user id ... ', 'dzsflb' );
							}

						}
					}
				}
			}
		}


	}










	function handle_init(){
		wp_enqueue_script('jquery');

		if (is_admin()) {
			if (current_user_can('edit_posts') || current_user_can('edit_pages')) {
				if (get_user_option('rich_editing') == 'true') {
				}
			}

			if(isset($_GET['page']) && $_GET['page']==$this->adminpagename_mainoptions){
				wp_enqueue_script('dzsflb-mo', $this->base_url.'assets/admin-mo.js');
			}
			wp_enqueue_style('dzsflb-admin-global', $this->base_url.'assets/admin-global.css');
		}
		add_action('admin_menu',array($this,'handle_admin_menu'));

		$this->check_posts();
	}

	function generate_style($lab,$style){




	    $fout = '';



	    $fout.=''.$lab.' ';

	    if($style=='button'){
	        $fout.='{';

	        $fout.='background-color: #b531a4!important;';
	        $fout.='color: #fff!important;';
	        $fout.='padding: 10px!important;';
	        $fout.='line-height: 1!important;';
	        $fout.='border-radius: 5px!important;';
	        $fout.='border: 0px!important;';
	        $fout.='opacity: 1!important;';
	        $fout.='transition: all 0.3s ease-out!important;';



	        $fout.='}';

		    $fout.=''.$lab.':hover ';

		    if(1) {
			    $fout .= '{';
			    $fout .= 'opacity: 0.85!important;';


			    $fout .= '}';
		    }

        }

		if($style=='icon-1'){

			$fout.='{';

			$fout.='font-size: 0!important;';
			$fout.='opacity: 1!important;';
			$fout.='text-decoration: none!important;';
			$fout.='border:0!important;';
			$fout.='transition: all 0.3s ease-out!important;';



			$fout.='}';

			$fout.=''.$lab.':before ';

			if(1) {
				$fout .= '{';
				$fout .= 'content: "\f2bd"!important;';
				$fout .= 'font-size: 15px;';
				$fout .= 'font-family: "FontAwesome",arial;';


				$fout .= '}';
			}

			$fout.=''.$lab.':hover ';

			if(1) {
				$fout .= '{';
				$fout .= 'opacity: 0.85!important;';


				$fout .= '}';
			}

	        wp_enqueue_style('fontawesome',"https://use.fontawesome.com/releases/v5.0.6/css/all.css");
		}

	    return $fout;

    }

	function handle_wp_head(){


//	    print_r($this->db_main_options);
		echo '<style class="dzsflb-button-styling">';

	    if($this->db_main_options['style_login']){


	        echo $this->generate_style('a[href="#login-box"]',$this->db_main_options['style_login']);
        }

        $lab = 'style_login_login';
	    if($this->db_main_options[$lab]){


	        echo $this->generate_style('a[href="#login-box--login"]',$this->db_main_options[$lab]);
        }

        $lab = 'style_login_register';
	    if($this->db_main_options[$lab]){


	        echo $this->generate_style('a[href="#login-box--register"]',$this->db_main_options[$lab]);
        }



		echo '</style>';

	    if($this->db_main_options['extra_css']){


	        echo '<style class="dzsflb-extra-css">'.$this->db_main_options['extra_css'].'</style>';

        }


	}


	function handle_admin_menu(){


//        echo 'ceva';



		$admin_cap = $this->capability_admin;
		$dzsvcs_page = add_menu_page(__('Login box ','dzsflb'),__('Login box ','dzsflb'),$admin_cap,$this->adminpagename_mainoptions,array($this,'admin_page_mainoptions'),'div');

	}
	function admin_page_mainoptions() {

	    include_once "class_parts/admin-page-mainoptions.php";



		wp_enqueue_script('dzssel',$this->base_url.'libs/dzsselector/dzsselector.js');
		wp_enqueue_style('dzssel',$this->base_url.'libs/dzsselector/dzsselector.css');

	}


	/**
	 * let_to_num function.
	 *
	 * This function transforms the php.ini notation for numbers (like '2M') to an integer.
	 *
	 * @param $size
	 * @return int
	 */
	function wc_let_to_num( $size ) {
		$l   = substr( $size, -1 );
		$ret = substr( $size, 0, -1 );
		switch ( strtoupper( $l ) ) {
			case 'P':
				$ret *= 1024;
			case 'T':
				$ret *= 1024;
			case 'G':
				$ret *= 1024;
			case 'M':
				$ret *= 1024;
			case 'K':
				$ret *= 1024;
		}
		return $ret;
	}


}