<?php
$nonce_lab = 'nonce_dzsflb';
$nonce = wp_create_nonce($nonce_lab);
$_SESSION[$nonce_lab]=$nonce;
?>



<div class="wrap wrap-for-dzsflb-mo">
    <h2><?php echo __('Login box settings', 'dzsvg'); ?></h2>
    <br/>


    <form class="dzsflb-mo">
		<?php

		echo DZSHelpers::generate_input_text($nonce_lab,array(
			'class'=>'',
			'input_type'=>'hidden',
			'seekval'=>$nonce,
		))
		?>
        <div class="setting">
            <h5 class="setting-label">Facebook <?php echo esc_html__('application id','dzsflb'); ?></h5>
			<?php
			$lab = 'facebook_app_id';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_input_text($lab,array(
				'class'=>'',
				'seekval'=>$val,
			))
			?>
            <div class="sidenote"><?php echo esc_html__('tutorial','dzsflb'); ?> <a href="http://zoomthe.me/knowledge-base/video-gallery/knowledge-base/facebook-create-application-for-getting-application-id-and-application-secret/" target="_blank"><?php echo esc_html__('here','dzsflb'); ?></a></div>
        </div>
        <div class="setting">
            <h5 class="setting-label">Facebook <?php echo esc_html__('application secret','dzsflb'); ?></h5>
			<?php
			$lab = 'facebook_app_secret';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_input_text($lab,array(
				'class'=>'',
				'seekval'=>$val,
			))
			?>
        </div>
        <div class="setting">
            <h5 class="setting-label">Google <?php echo esc_html__('recapcha key','dzsflb'); ?></h5>
			<?php
			$lab = 'google_recapcha_key';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_input_text($lab,array(
				'class'=>'',
				'seekval'=>$val,
			))
			?>
        </div>
        <div class="setting">
            <h5 class="setting-label">Google <?php echo esc_html__('recapcha secret','dzsflb'); ?></h5>
			<?php
			$lab = 'google_recapcha_secret';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_input_text($lab,array(
				'class'=>'',
				'seekval'=>$val,
			))
			?>
        </div>
        <div class="setting">
            <h5 class="setting-label"><?php echo esc_html__('Extra','dzsflb'); ?> css</h5>
			<?php
			$lab = 'extra_css';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_input_textarea($lab,array(
				'class'=>'',
				'extraattr'=>' style="width: 100%; max-width: 600px;"',
				'seekval'=>$val,
			))
			?>
        </div>
        <div class="setting">
            <h5 class="setting-label"><?php echo esc_html__('Login style','dzsflb'); ?></h5>
			<?php
			$lab = 'style_login';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_select($lab,array(
				'class'=>'dzs-style-me  opener-listbuttons ',
				'options'=>array(
				        array(
				            'value'=>'',
				            'label'=>'',
                        ),
				        array(
				            'value'=>'button',
				            'label'=>'',
                        ),
				        array(
				            'value'=>'icon-1',
				            'label'=>'',
                        ),
                ),
				'seekval'=>$val,
			))





			?>
            <ul class="dzs-style-me-feeder">

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-unstyled.jpg"><span class="option-label"><?php echo esc_html__('Unstyled','dzsflb'); ?></span></span>
                </div>

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-button.jpg"><span class="option-label"><?php echo esc_html__('Button style','dzsflb'); ?></span></span>
                </div>

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-icon-1.jpg"><span class="option-label"><?php echo esc_html__('Icon style','dzsflb'); ?></span></span>
                </div>
            </ul>
        </div>

        <br>
        <div class="setting">
            <h5 class="setting-label"><?php echo esc_html__('Login - login style','dzsflb'); ?></h5>
			<?php
			$lab = 'style_login_login';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_select($lab,array(
				'class'=>'dzs-style-me  opener-listbuttons ',
				'options'=>array(
				        array(
				            'value'=>'',
				            'label'=>'',
                        ),
				        array(
				            'value'=>'button',
				            'label'=>'',
                        ),
				        array(
				            'value'=>'icon-1',
				            'label'=>'',
                        ),
                ),
				'seekval'=>$val,
			))





			?>
            <ul class="dzs-style-me-feeder">

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-unstyled.jpg"><span class="option-label"><?php echo esc_html__('Unstyled','dzsflb'); ?></span></span>
                </div>

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-button.jpg"><span class="option-label"><?php echo esc_html__('Button style','dzsflb'); ?></span></span>
                </div>

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-icon-1.jpg"><span class="option-label"><?php echo esc_html__('Icon style','dzsflb'); ?></span></span>
                </div>
            </ul>
        </div>

        <br>
        <div class="setting">
            <h5 class="setting-label"><?php echo esc_html__('Login - register style','dzsflb'); ?></h5>
			<?php
			$lab = 'style_login_register';

			$val = '';

			if($this->db_main_options[$lab]){
				$val = $this->db_main_options[$lab];
			}
			echo DZSHelpers::generate_select($lab,array(
				'class'=>'dzs-style-me  opener-listbuttons ',
				'options'=>array(
				        array(
				            'value'=>'',
				            'label'=>'',
                        ),
				        array(
				            'value'=>'button',
				            'label'=>'',
                        ),
				        array(
				            'value'=>'icon-1',
				            'label'=>'',
                        ),
                ),
				'seekval'=>$val,
			))





			?>
            <ul class="dzs-style-me-feeder">

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-unstyled.jpg"><span class="option-label"><?php echo esc_html__('Unstyled','dzsflb'); ?></span></span>
                </div>

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-button.jpg"><span class="option-label"><?php echo esc_html__('Button style','dzsflb'); ?></span></span>
                </div>

                <div class="bigoption">
                    <span class="option-con"><img src="<?php echo $this->base_url; ?>assets/img/style-icon-1.jpg"><span class="option-label"><?php echo esc_html__('Icon style','dzsflb'); ?></span></span>
                </div>
            </ul>
        </div>

        <br>

        <br>
        <p class="submit-buttons">
            <button class="button-primary btn-save-mo"><?php echo esc_html__('Save options','dzsflb'); ?></button>
        </p>
    </form>

    <div class="saveconfirmer"><?php echo esc_html__('Loading','dzsflb'); ?></div>
